#ifndef MAINWINDOWIMPL_H
#define MAINWINDOWIMPL_H
//
#include <QMainWindow>
#include "mdichild.h"
#include "ui_mainwindow.h"
#include "ui_Renumber.h"
#include "ui_FindDialog.h"
#include "ui_GotoLine.h"
#include "ui_extracharacters.h"
#include "ui_config.h"
#include "ui_AboutEditor.h"
#include "ui_AboutQt.h"
#include "ui_d64Dir.h"
#include "ui_FileNameDialog.h"
#include "ui_AsmResults.h"
#ifndef WIN_32
#include <X11/Xlib.h>
#include <X11/keysym.h>
#endif
//
class MainWindowImpl : public QMainWindow, public Ui::MainWindow
{
Q_OBJECT
public:
	MainWindowImpl( QWidget * parent = 0, Qt::WFlags f = 0 );
	~MainWindowImpl();
private:
	char*			DirNamePtr[8*18];
	QString		fndtxt;
	int			prst;
	int			d64but;
	int			arrange;
	int			txttab;
	ushort		lastChecked;
	bool			Capslok;
	bool			Numlok;
	bool			Scrolok;
	bool			FileNameChanged;
#ifndef WIN_32
	bool			keyState(int iKey,Display *pDisplay);
#endif
	void			SetupChild(MdiChild*);
	int			calcOff(uchar,uchar);
	int			RecentFileType[8];
	int			PostSave(MdiChild*,uchar*,int);
	int			RenumberEx(int,int,ushort*,int,ushort*,const uchar*,PRGLines*,int);
	int			Renumber();
	ushort		MakeLocal(int,ushort*,ushort*,PRGLines*,int);
	bool			OpenPRG(int);
	bool			SavePRGFile();
	int			DoD64File();
	bool			RenumberInProgress;
	bool			SubLoad(QString,QString);
	bool			PreSave(MdiChild*,int);
	bool			WriteD64(uchar,uchar,int,int,uchar*,uchar*);
	QMdiSubWindow*	findMdiChild(const QString &);
	MdiChild*	createMdiChild();
	Ui_ConfigDialog* cfgdlg;
	QString		Prgdir;
	QString		Txtdir;
	QString		Datadir;
	QString		D64Dir;
	QString		AsmCmdLine;
	QString		Prgfnt;
	QString		Txtfnt;
	QString		Datafnt;
	QString		Prgfntsz;
	QString		Txtfntsz;
	QString		Datafntsz;
	QString		Tabspace;
	QString		inifile;
	QString		PRGHeader;
	QString		BasicHeader;
	QString		DataHeader;
	QString		D64Header;
	QString		PRGType;
	QString		BasicType;
	QString		DataType;
	QString		D64Type;
	QString		TxtLineHighlight;
	QString		RecentFiles[8];
	QString		fn;
	QString		h1;
	QString		d1;
	QString 		homedir;
	QAction*		RecentFilesAction[8];
	QMenu* 		recentfiles;
	QFont			PRGfont;
	QFont			Txtfont;
	QFont			Datafont;
	QSize			bsize;
	QLabel*		Numlock;
	QLabel*		Capslock;
	QLabel*		Scrolllock;
	QLabel*		ColumnCursor;
	QDialog*		FndDlg;
	QDialog* 	AboutDialog;
	QDialog*		Aboutqt;
	QDialog*		CfgDialog;
	QDialog*		InsDialog;
	QDialog*		fnlog;
	QDialog*		GotoDlg;
	QDialog*		d64Dialog;
	QDialog*		RenDlg;
	QDialog*		AsmResDialog;
private slots:
	void			D64ButtonPressed();
	void			DeCursorPositionChanged();
	void			on_actionOpenD64_activated();
	void			on_actionSaveD64_activated();
	void			actionRecentFiles();
	void			actionConfigDirChoise();
	void			on_actionConfig_activated();
	void			insertKeysPressed();
	void			on_actionPRGnew_activated();
	void			on_actionTXTnew_activated();
	void			on_actionPetUpperCase_activated();
	void			on_actionPetLowerCase_activated();
	void			on_actionRenumber_activated();
	void			on_actionCascade_activated();
	void			on_actionTile_activated();
	void			on_actionMinimize_activated();
	void			on_actionAbout_BasicEditor_activated();
	void			on_actionHelp_activated();
	void			on_actionAbout_Qt_activated();
	void			on_actionConfiguration_activated();
	void			on_actionFont_activated();
	void			on_actionOpen_PRG_File_activated();
	void			on_actionOpen_BAS_or_Text_activated();
	void			on_actionOpen_Data_File_activated();
	void			on_actionSave_as_PRG_activated();
	void			on_actionSave_as_BAS_Text_activated();
	void			on_actionSave_Data_File_activated();
	void			on_actionGoto_Line_activated();
	void			on_actionAssemble_activated();
	void			on_toolButton_clicked();
	void			on_toolButton_2_clicked();
	void			on_toolButton_5_clicked();
	void			on_toolButton_6_clicked();
	void			on_toolButton_7_clicked();
	void			on_toolButton_8_clicked();
	void			on_toolButton_9_clicked();
	void			on_assemble_button_clicked();
	void			on_lineEdit_textChanged(QString );
	void			on_lineEdit_2_textChanged(QString );
	void			fileRename(QTableWidgetItem*);
protected:
	virtual bool	event(QEvent* ev);
};
#endif




