#include <QtGui>
#include "mdichild.h"

extern "C" {
	QString	Abs;
	QString	And;
	QString	Asc;
	QString	Atn;
	QString	ChrStr;
	QString	Close;
	QString	Clr;
	QString	Cmd;
	QString	Cont;
	QString	Cos;
	QString	Data;
	QString	Def;
	QString	Dim;
	QString	End;
	QString	Exp;
	QString	Fn;
	QString	For;
	QString	Fre;
	QString	Get;
	QString	GetNum;
	QString	Go;
	QString	Gosub;
	QString	Goto;
	QString	If;
	QString	Input;
	QString	InputNum;
	QString	Int;
	QString	LeftStr;
	QString	Len;
	QString	Let;
	QString	List;
	QString	Load;
	QString	Log;
	QString	MidStr;
	QString	New;
	QString	Next;
	QString	Not;
	QString	On;
	QString	Open;
	QString	Or;
	QString	Peek;
	QString	Pi;
	QString	Poke;
	QString	Pos;
	QString	Print;
	QString	PrintNum;
	QString	Read;
	QString	Rem;
	QString	Restore;
	QString	Return;
	QString	RightStr;
	QString	Rnd;
	QString	Run;
	QString	Save;
	QString	Sgn;
	QString	Sin;
	QString	SpcBr;
	QString	Sqr;
	QString	Status;
	QString	Step;
	QString	Stop;
	QString	StrStr;
	QString	Sys;
	QString	TabBr;
	QString	Tan;
	QString	Then;
	QString	To;
	QString	Usr;
	QString	Val;
	QString	Verify;
	QString	Wait;
}

void MdiChild::Init()
{
	Abs = "ABS";
	And = "AND";
	Asc = "ASC";
	Atn = "ATN";
	ChrStr = "CHR$";
	Close = "CLOSE";
	Clr = "CLR";
	Cmd = "CMD";
	Cont = "CONT";
	Cos = "COS";
	Data = "DATA";
	Def = "DEF";
	Dim = "DIM";
	End = "END";
	Exp = "EXP";
	Fn = "FN";
	For = "FOR";
	Fre = "FRE";
	Get = "GET";
	Go = "GO";
	Gosub = "GOSUB";
	Goto = "GOTO";
	If = "IF";
	Input = "INPUT";
	InputNum = "INPUT#";
	Int = "INT";
	LeftStr = "LEFT$";
	Len = "LEN";
	Let = "LET";
	List = "LIST";
	Load = "LOAD";
	Log = "LOG";
	MidStr = "MID$";
	New = "NEW";
	Next = "NEXT";
	Not = "NOT";
	On = "ON";
	Open = "OPEN";
	Or = "OR";
	Peek = "PEEK";
	Pi = "PI";
	Poke = "POKE";
	Pos = "POS";
	Print = "PRINT";
	PrintNum = "PRINT#";
	Read = "READ";
	Rem = "REM";
	Restore = "RESTORE";
	Return = "RETURN";
	RightStr = "RIGHT$";
	Rnd = "RND";
	Run = "RUN";
	Save = "SAVE";
	Sgn = "SGN";
	Sin = "SIN";
	SpcBr = "SPC(";
	Sqr = "SQR";
	Status = "STATUS";
	Step = "STEP";
	Stop = "STOP";
	StrStr = "STR$";
	Sys = "SYS";
	TabBr = "TAB(";
	Tan = "TAN";
	Then = "THEN";
	To = "TO";
	Usr = "USR";
	Val = "VAL";
	Verify = "VERIFY";
	Wait = "WAIT";	
}

MdiChild::MdiChild()
{
	setAttribute(Qt::WA_DeleteOnClose);
	isUntitled = true;
	lines = NULL;
	horizontalScrollBar();
	dataBuffer = NULL;
}

MdiChild::~MdiChild()
{
	if(dataBuffer != NULL)
		delete dataBuffer;
}

void MdiChild::InitLineNumber()
{
	lineNumberArea = new LineNumberArea(this);
	connect(this,SIGNAL(blockCountChanged(int)),this,
		SLOT(updateLineNumberAreaWidth(int)));
	connect(this,SIGNAL(updateRequest(QRect,int)),this,
		SLOT(updateLineNumberArea(QRect,int)));
	if(HighlightTxt)
		connect(this,SIGNAL(cursorPositionChanged()),this,
			SLOT(highlightCurrentLine()));
	updateLineNumberAreaWidth(0);
	if(HighlightTxt)
		highlightCurrentLine();
	typeFile = 1;
}

int MdiChild::lineNumberAreaWidth()
{
	int digits = 1;
	int max = qMax(1,blockCount());
	while (max >= 10)
	{
		max /= 10;
		++digits;
	}
	return (3 + (fontMetrics().width(QLatin1Char('9')) * digits));
 }

void MdiChild::updateLineNumberAreaWidth(int /* newBlockCount */)
{
	setViewportMargins(lineNumberAreaWidth(),0,0,0);
}

 void MdiChild::updateLineNumberArea(const QRect &rect,int dy)
 {
 	if(dy)
		lineNumberArea->scroll(0,dy);
	else
		lineNumberArea->update(0,rect.y(),lineNumberArea->width(),rect.height());
	if(rect.contains(viewport()->rect()))
		updateLineNumberAreaWidth(0);
}

void MdiChild::resizeEvent(QResizeEvent *e)
{
	QPlainTextEdit::resizeEvent(e);
	if(typeFile == 1)
	{
		QRect cr = contentsRect();
		lineNumberArea->setGeometry(QRect(cr.left(),cr.top(),
			lineNumberAreaWidth(),cr.height()));
	}
}

 void MdiChild::highlightCurrentLine()
 {
	QList<QTextEdit::ExtraSelection> extraSelections;
	if (!isReadOnly())
	{
		QTextEdit::ExtraSelection selection;
		QColor lineColor = QColor(Qt::yellow).lighter(160);
		selection.format.setBackground(lineColor);
		selection.format.setProperty(QTextFormat::FullWidthSelection,true);
		selection.cursor = textCursor();
		selection.cursor.clearSelection();
		extraSelections.append(selection);
	}
	setExtraSelections(extraSelections);
}

void MdiChild::lineNumberAreaPaintEvent(QPaintEvent *event)
{
	QPainter painter(lineNumberArea);
	painter.fillRect(event->rect(),Qt::lightGray);
	QTextBlock block = firstVisibleBlock();
	int blockNumber = block.blockNumber();
	int top = (int)blockBoundingGeometry(block).translated(contentOffset()).top();
	int bottom = top + (int)blockBoundingRect(block).height();
	while (block.isValid() && top <= event->rect().bottom())
	{
		if(block.isVisible() && bottom >= event->rect().top())
		{
			QString number = QString::number(blockNumber + 1);
			painter.setPen(Qt::black);
			painter.drawText(0,top,lineNumberArea->width(),fontMetrics().height(),
				Qt::AlignRight,number);
		}
		block = block.next();
		top = bottom;
		bottom = top + (int)blockBoundingRect(block).height();
		++blockNumber;
	}
}

void MdiChild::print()
{
#ifndef QT_NO_PRINTER
	QPrinter obPrint;
	QPrintDialog* pobPrintDialog = new QPrintDialog(&obPrint);
	if(pobPrintDialog->exec()== QDialog::Accepted)
		document()->print(&obPrint);
	delete pobPrintDialog;
#endif
}

void MdiChild::newFile(int typefil)
{
	static int sequenceNumber = 1;
	typeFile = typefil & 127;
	if(typeFile == 0)
	{
		if(!(typefil & 128))
			curFile = tr("BASICFILE%1.PRG").arg(sequenceNumber++);
		setWordWrapMode(QTextOption::NoWrap);
	}
	else
	{
		if(!(typefil & 128))
			curFile = tr("TextFile%1.txt").arg(sequenceNumber++);
	}
	if(FileOnDisk)
		setWindowTitle(userFriendlyCurrentFile() + "[*]");
	else
		setWindowTitle(curFile + "[*]");
	connect(document(),SIGNAL(contentsChanged()),
		this,SLOT(documentWasModified()));
}

bool MdiChild::loadFile(const QString &fileName)
{
	QFile file(fileName);
	if(!file.open(QFile::ReadOnly|QFile::Text))
	{
		QMessageBox::warning(this,tr("MDI"),tr("Cannot read file %1:\n%2.")
			.arg(fileName).arg(file.errorString()));
		return false;
	}
	QTextStream in(&file);
	QApplication::setOverrideCursor(Qt::WaitCursor);
	setPlainText(in.readAll());
	QApplication::restoreOverrideCursor();
	setCurrentFile(fileName);
	connect(document(),SIGNAL(contentsChanged()),
		this,SLOT(documentWasModified()));
	setWordWrapMode(QTextOption::NoWrap);
	return true;
}

void MdiChild::lastLoad()
{
	connect(document(),SIGNAL(contentsChanged()),
		this,SLOT(documentWasModified()));
	setWordWrapMode(QTextOption::NoWrap);
	SetFile();
}

bool MdiChild::loadPRG(const QString &fileName)
{
	QFile file(fileName);
	if(!file.open(QFile::ReadOnly))
	{
		QMessageBox::warning(this,tr("MDI"),tr("Cannot read file %1:\n%2.")
			.arg(fileName).arg(file.errorString()));
		return false;
	}
	int i = file.size();
	QByteArray OrignalPRG;
	OrignalPRG.resize(i);
	file.read(OrignalPRG.data(),i);
	file.close();
	if(newPRGLoad(OrignalPRG.data(),i))
	{
		setCurrentFile(fileName);
		return true;
	}
	else
		return false;	
}

bool MdiChild::newPRGLoad(char* ibuf,int i)
{
	QString uitbuf;
	QString zbuf;
	int jlin = InitPRG(ibuf,i);
	if(jlin == -1)
		return false;
	for(i = 0; i < jlin;i++)
	{
		zbuf.setNum(lines[i].OrignalLineNumber);
		uitbuf += (zbuf + " ");
		uitbuf += lines[i].TranslatedLine;
		uitbuf += "\n";
	}
	setPlainText(uitbuf);
	setWordWrapMode(QTextOption::NoWrap);
	connect(document(),SIGNAL(contentsChanged()),
		this,SLOT(documentWasModified()));
	typeFile = 0;
	return true;
}

bool MdiChild::loadData(const QString &fileName)
{
	QFile file(fileName);
	if(!file.open(QFile::ReadOnly))
	{
		QMessageBox::warning(this,tr("MDI"),tr("Cannot read file %1:\n%2.")
			.arg(fileName).arg(file.errorString()));
		return false;
	}
	int i = file.size();
	dataBuffer = new char[i+16];
	dataBuffersz = i;
	file.read(dataBuffer,i);
	file.close();
	setCurrentFile(fileName);
	SubloadData(dataBuffer,i);
	return true;
}

void MdiChild::SubloadData(char* datbuf,int i)
{
	setReadOnly(true);
	setWordWrapMode(QTextOption::NoWrap);
	QString uitbuf;
	char tstr[80];
	for(int j = 0;j < i;)
	{
		sprintf(tstr,"%4.4X  ",j);
		for(int k = 6,m = 55;k < 54;k+=3,m++)
		{
			if(j == i)
			{
				for(;k < 54;k+=3,m++)
				{
					tstr[m] = ' ';
					tstr[k] = ' ';
					tstr[k+1] = ' ';
					tstr[k+2] = ' ';
				}
				break;
			}
			uchar b = datbuf[j++];
			sprintf(tstr+k,"%2.2X ",b);
			if(b < 32)
				b = '.';
			tstr[m] = b;
		}
		tstr[54] = ' ';
		tstr[71] = '\n';
		tstr[72] = 0;
		uitbuf.append(tstr);
	}
	typeFile = 2;
	setPlainText(uitbuf);
}

bool MdiChild::save()
{
	if(isUntitled)
		return saveAs();
	else
		return saveFile(curFile);
}

bool MdiChild::saveAs()
{
	QString fileName = QFileDialog::getSaveFileName(this,tr("Save As"),curFile);
	if (fileName.isEmpty())
		return false;
	return saveFile(fileName);
}

bool MdiChild::saveFile(const QString &fileName)
{
	QFile file(fileName);
	if(!file.open(QIODevice::WriteOnly|QIODevice::Text))
	{
		QMessageBox::warning(this,tr("MDI"),tr("Cannot write file %1:\n%2.")
			.arg(fileName).arg(file.errorString()));
		return false;
	}
   QTextStream out(&file);
   QApplication::setOverrideCursor(Qt::WaitCursor);
   out << toPlainText();
   QApplication::restoreOverrideCursor();
   setCurrentFile(fileName);
	return true;
}

QString MdiChild::userFriendlyCurrentFile()
{
	return strippedName(curFile);
}

void MdiChild::closeEvent(QCloseEvent *event)
{
   if(maybeSave())
		event->accept();
	else
		event->ignore();
}

void MdiChild::documentWasModified()
{
	setWindowModified(document()->isModified());
}

bool MdiChild::maybeSave()
{
	if(document()->isModified())
	{
      if(typeFile == 1)
      {
         QMessageBox::StandardButton ret;
         ret = QMessageBox::warning(this,tr("MDI"),tr("'%1' has been modified.\n"
            "Do you want to save your changes?").arg(userFriendlyCurrentFile()),
            QMessageBox::Save|QMessageBox::Discard|QMessageBox::Cancel);
         if(ret == QMessageBox::Save)
         {
            if(FileOnDisk)
               return save();
            else
               D64Action->activate(QAction::Trigger);
         }
         else if(ret == QMessageBox::Cancel)
            return false;
      }
      else
      {
          QMessageBox::StandardButton reto = QMessageBox::warning(this,tr("Save Basic PRG File?")
             ,tr("This file has not been saved. To discard the changes press Yes. to continue editing press No"),
             QMessageBox::Yes|QMessageBox::No);
          if(reto == QMessageBox::No)
             return 0;
      }
	}
	return true;
}

void MdiChild::SetFile()
{
	isUntitled = false;
	document()->setModified(false);
	setWindowModified(false);	
}

void MdiChild::setCurrentFile(const QString &fileName)
{
	curFile = QFileInfo(fileName).canonicalFilePath();
	isUntitled = false;
	document()->setModified(false);
	setWindowModified(false);
	setWindowTitle(userFriendlyCurrentFile() + "[*]");
}

QString MdiChild::strippedName(const QString &fullFileName)
{
	return QFileInfo(fullFileName).fileName();
}

void MdiChild::ResizePRGLines(int i)
{
	if(lines != NULL)
		delete[] lines;
	lines = new PRGLines[i];
}

int MdiChild::InitPRG(char* cbegin,int i)
{
	if((cbegin[0] != 1) && (cbegin[1] != 8))
	{
		QMessageBox::StandardButton ret = QMessageBox::warning(this,tr("Basic PRG File?")
			,tr("This file does not have a standard Basic file format.\nIt might not display properly.\nDo you really want to continue?"),
			QMessageBox::Yes|QMessageBox::No);
		if(ret == QMessageBox::No)
			return -1;
   }
	ushort* sptr = (ushort*)cbegin;
	ushort begin = sptr[0]-2;
	ushort nxtptr = sptr[1] - begin;
	int numlines = 1;
	ushort chknxtptr = nxtptr;
	for(;nxtptr < (ushort)(i-2);numlines++)
	{
      sptr = (ushort*)(cbegin + (int)nxtptr);
      if(sptr[0] == 0)
			break;
      for(nxtptr = chknxtptr+4;cbegin[nxtptr] != 0;nxtptr++);
      nxtptr++;
      if(nxtptr-chknxtptr > 85)
		{
			QMessageBox::warning(this,tr("Line Length Errors!"),
            tr("Line number %1 is too long! It has %2 charaacters.\nThis file may not work correctly on the Commodore but this program will edit it. Please correct this problem.")
            .arg(sptr[1]).arg(nxtptr-chknxtptr-5));
		}
		chknxtptr = nxtptr;
	}
	lines = new PRGLines[numlines+10];
	nxtptr = 2;
	uchar* orgstr;
	uchar m,rr;
	for(int j = 0; j < numlines;j++)
	{
		sptr = (ushort*)(cbegin + (int)nxtptr);
		lines[j].OrignalLineOffset = sptr[0];
		lines[j].OrignalLineNumber = sptr[1];
		orgstr = (uchar*)sptr + 4;
		for(rr = 0;orgstr[rr] != 0;rr++)
			lines[j].OrignalLine[rr] = orgstr[rr];
		lines[j].OrignalLine[rr] = 0;
      nxtptr += (rr + 5);
      lines[j].TranslatedLine = "";
		for(int k = 0;k < rr;k++)
		{
			m = orgstr[k];
			switch(m)
			{
				case 34:
					do
					{
						lines[j].TranslatedLine += orgstr[k++];
						if(orgstr[k] == 34)
						{
							lines[j].TranslatedLine += "\"";
							break;
						}
					}while( k != rr-1);
				break;	
				case 182:
					lines[j].TranslatedLine += Abs;
				break;
				case 175:
					lines[j].TranslatedLine += And;
				break;
				case 198:
					lines[j].TranslatedLine += Asc;
				break;
				case 193:
					lines[j].TranslatedLine += Atn;
				break;
				case 199:
					lines[j].TranslatedLine += ChrStr;
				break;
				case 160:
					lines[j].TranslatedLine += Close;
				break;
				case 156:
					lines[j].TranslatedLine += Clr;
				break;
				case 157:
					lines[j].TranslatedLine += Cmd;
				break;
				case 154:
					lines[j].TranslatedLine += Cont;
				break;
				case 190:
					lines[j].TranslatedLine += Cos;
				break;
				case 131:
					lines[j].TranslatedLine += Data;
				break;
				case 150:
					lines[j].TranslatedLine += Def;
				break;
				case 134:
					lines[j].TranslatedLine += Dim;
				break;
				case 128:
					lines[j].TranslatedLine += End;
				break;
				case 189:
					lines[j].TranslatedLine += Exp;
				break;
				case 165:
					lines[j].TranslatedLine += Fn;
				break;
				case 129:
					lines[j].TranslatedLine += For;
				break;
				case 184:
					lines[j].TranslatedLine += Fre;
				break;
				case 161:
					lines[j].TranslatedLine += Get;
				break;
				case 141:
					lines[j].TranslatedLine += Gosub;
				break;
				case 137:
					lines[j].TranslatedLine += Goto;
				break;
				case 139:
					lines[j].TranslatedLine += If;
				break;
				case 132:
					lines[j].TranslatedLine += InputNum;
				break;
				case 133:
					lines[j].TranslatedLine += Input;
				break;
				case 181:
					lines[j].TranslatedLine += Int;
				break;
				case 200:
					lines[j].TranslatedLine += LeftStr;
				break;
				case 195:
					lines[j].TranslatedLine += Len;
				break;
				case 136:
					lines[j].TranslatedLine += Let;
				break;
				case 155:
					lines[j].TranslatedLine += List;
				break;
				case 147:
					lines[j].TranslatedLine += Load;
				break;
				case 188:
					lines[j].TranslatedLine += Log;
				break;
				case 202:
					lines[j].TranslatedLine += MidStr;
				break;
				case 162:
					lines[j].TranslatedLine += New;
				break;
				case 130:
					lines[j].TranslatedLine += Next;
				break;
				case 168:
					lines[j].TranslatedLine += Not;
				break;
				case 145:
					lines[j].TranslatedLine += On;
				break;
				case 159:
					lines[j].TranslatedLine += Open;
				break;
				case 176:
					lines[j].TranslatedLine += Or;
				break;
				case 194:
					lines[j].TranslatedLine += Peek;
				break;
				case 151:
					lines[j].TranslatedLine += Poke;
				break;
				case 185:
					lines[j].TranslatedLine += Pos;
				break;
				case 152:
					lines[j].TranslatedLine += PrintNum;
				break;
				case 153:
					lines[j].TranslatedLine += Print;
				break;
				case 135:
					lines[j].TranslatedLine += Read;
				break;
				case 143:
					lines[j].TranslatedLine += Rem;
				break;
				case 140:
					lines[j].TranslatedLine += Restore;
				break;
				case 142:
					lines[j].TranslatedLine += Return;
				break;
				case 201:
					lines[j].TranslatedLine += RightStr;
				break;
				case 187:
					lines[j].TranslatedLine += Rnd;
				break;
				case 138:
					lines[j].TranslatedLine += Run;
				break;
				case 148:
					lines[j].TranslatedLine += Save;
				break;
				case 180:
					lines[j].TranslatedLine += Sgn;
				break;
				case 191:
					lines[j].TranslatedLine += Sin;
				break;
				case 166:
					lines[j].TranslatedLine += SpcBr;
				break;
				case 186:
					lines[j].TranslatedLine += Sqr;
				break;
				case 169:
					lines[j].TranslatedLine += Step;
				break;
				case 144:
					lines[j].TranslatedLine += Stop;
				break;
				case 196:
					lines[j].TranslatedLine += StrStr;
				break;
				case 158:
					lines[j].TranslatedLine += Sys;
				break;
				case 163:
					lines[j].TranslatedLine += TabBr;
				break;
				case 192:
					lines[j].TranslatedLine += Tan;
				break;
				case 167:
					lines[j].TranslatedLine += Then;
				break;
				case 164:
					lines[j].TranslatedLine += To;
				break;
				case 183:
					lines[j].TranslatedLine += Usr;
				break;
				case 197:
					lines[j].TranslatedLine += Val;
				break;
				case 149:
					lines[j].TranslatedLine += Verify;
				break;
				case 146:
					lines[j].TranslatedLine += Wait;
				break;
				case 170:
					lines[j].TranslatedLine += "+";
				break;
				case 171:
					lines[j].TranslatedLine += "-";
				break;
				case 172:
					lines[j].TranslatedLine += "*";
				break;
				case 173:
					lines[j].TranslatedLine += "/";
				break;
				case 174:
					lines[j].TranslatedLine += "^";
				break;
				case 177:
					lines[j].TranslatedLine += ">";
				break;
				case 178:
					lines[j].TranslatedLine += "=";
				break;
				case 179:
					lines[j].TranslatedLine += "<";
				break;
				case 203:
					lines[j].TranslatedLine += Go;
				break;
				case 255:
					lines[j].TranslatedLine += Pi;
				break;
				default:
					lines[j].TranslatedLine += m;
				break;
			}
		}
	}
	return numlines;
}

