#ifndef MDICHILD_H
#define MDICHILD_H

#include <QPlainTextEdit>

struct PRGLines
{
   unsigned char	OrignalLine[256];
	QString			TranslatedLine;
	unsigned short	OrignalLineNumber;
	unsigned short	OrignalLineOffset;
};

class MdiChild : public QPlainTextEdit
{
Q_OBJECT
public:
	MdiChild();
	~MdiChild();
	void			Init();
	void			newFile(int);
	void			print();
	void			ResizePRGLines(int);
	void			setCurrentFile(const QString &fileName);
	void			lineNumberAreaPaintEvent(QPaintEvent *event);
	void			lastLoad();
	void			SubloadData(char*,int);
	void			InitLineNumber();
	void			SetFile();
	bool			loadFile(const QString &fileName);
	bool			loadPRG(const QString &fileName);
	bool			loadData(const QString &fileName);
	bool			saveFile(const QString &fileName);
	bool			newPRGLoad(char*,int);
	bool			FileOnDisk;
	bool			HighlightTxt;
	int			InitPRG(char*,int);
	int			typeFile;
 	int			lineNumberAreaWidth();
	QString		LastOpenedD64;
	QString		userFriendlyCurrentFile();
	QString		currentFile() { return curFile; }
	QString		curFile;
	QAction*		D64Action;
   PRGLines*	lines;
	char*			dataBuffer;
	int			dataBuffersz;
protected:
	void			closeEvent(QCloseEvent *event);
	void			resizeEvent(QResizeEvent *event);
 private slots:
	void			documentWasModified();
	void			updateLineNumberAreaWidth(int newBlockCount);
	void			highlightCurrentLine();
	void			updateLineNumberArea(const QRect &, int);

 private:
	bool			maybeSave();
	QString		strippedName(const QString &fullFileName);
	bool			isUntitled;
	QWidget		*lineNumberArea;
	bool			save();
	bool			saveAs();
	void			SetTextEditOptimalSize();
};

class LineNumberArea : public QWidget
{
public:
LineNumberArea(MdiChild *editor) : QWidget(editor)
{
	codeEditor = editor;
}

QSize sizeHint() const
{
	return QSize(codeEditor->lineNumberAreaWidth(), 0);
}

protected:
void paintEvent(QPaintEvent *event)
{
	codeEditor->lineNumberAreaPaintEvent(event);
}

private:
	MdiChild *codeEditor;
};

#endif
